
# this will create a DKRNL32.DLL version which is compatible with
# SBLive SoundBlaster 16 emulation.
# the one module which has problems is thread.asm, because
# it uses exception 01 to interrupt the application, and SBEmu
# uses this exception as well (by accessing directly GDT/IDT)

!include <..\dirs>

!ifndef DEBUG
DEBUG=0
!endif

NAME=DKRNL32
LIBNAME=DKRNL32S

!if $(DEBUG)
AOPTD=-D_DEBUG
OUTDIR=SBEMUD
SRCDIR=DEBUG
!else
AOPTD=
OUTDIR=SBEMU
SRCDIR=RELEASE
!endif

#SRCMODS = thread.asm

OBJMODS = $(OUTDIR)\thread.obj $(OUTDIR)\thread3.obj

OTHERMODS=

ASMOPT= -c -nologo -Sg -D_KERNEL32_=1 -D?DIRECTDISP=1 $(AOPTD) -I$(INC32DIR)
ASM=ml.exe -coff $(ASMOPT) -D?FLAT=1 -Fl$* -Fo$* 

LOPTS= /NOLOGO /MAP /SUBSYSTEM:CONSOLE /DLL /NODEFAULTLIB

.SUFFIXES: .asm .obj


.asm{$(OUTDIR)}.obj:
    $(ASM) $<

$(OUTDIR)\$(NAME).DLL: $(OBJMODS) $(OUTDIR)\$(LIBNAME).lib $(OUTDIR)\$(NAME).obj $(NAME).def
    @if exist $*.DLL erase $*.DLL
    $(LINKBIN) @<<
$(OUTDIR)\$(NAME).obj $(OBJMODS) $(OUTDIR)\$(LIBNAME).lib
$(LOPTS) $(LOPTD)
/DEF:$(NAME).def /merge:.BASE=.data /OUT:$*.DLL
<<
!if $(DEBUG)==0
    @copy $*.DLL ..\..\Bin\*.* >NUL
!ifdef DLL32DIR
    @copy $*.DLL $(DLL32DIR)\*.*
!endif    
    @copy $*.lib $(LIBCOFF)\*.* >NUL
    @copy $(OUTDIR)\$(LIBNAME).lib $(LIBCOFF)\*.* >NUL
!endif    

$(OUTDIR)\$(LIBNAME).lib: $(OBJMODS) $(SRCDIR)\$(LIBNAME).lib
	@copy $(SRCDIR)\$(LIBNAME).lib  $*.LIB
    $(LIBBIN) $*.LIB /REMOVE:.\thread.obj /REMOVE:.\thread3.obj /OUT:$*.LIB 
    $(LIBBIN) $(OBJMODS) $*.LIB /OUT:$*.LIB 

$(OUTDIR)\$(NAME).OBJ: $(SRCDIR)\$(NAME).OBJ
	@copy $(SRCDIR)\$(NAME).OBJ  $*.OBJ

$(OBJMODS): dkrnl32.inc

clean:
	@del $(OUTDIR)\*.dll
	@del $(OUTDIR)\*.obj
	@del $(OUTDIR)\*.lib
	@del $(OUTDIR)\*.map
	@del $(OUTDIR)\*.lst
	@del $(OUTDIR)\*.exp
    
