
;*** MZ stub for HX DOS extended applications

_SFLAGS_   = 20h	;open with "deny write"

?MINMEM	 = 600h		;paragraphs which have to be free at least
MAXDIR   = 64+4		;max length of a directory path (including 00h)
MAXPATH  = MAXDIR+12

		.286
		include ascii.inc

_TEXT   segment

;--- the "16STUB" string is required by TDX.EXE
;--- but not sufficient!!!

ife ?32BIT
ifdef ?POWERPACK
		db "16STUB"
        db 0CAh dup (0)
endif
endif

;--- load DPMILDxx at start of memory block, then run it.
;--- CS=SS=DS=ES=DGROUP
;--- BX,DX,AX set for calling int 21h, ax=4B03h

szPgm   equ <[bp+06h]>     ;execute program name ("DPMIDLXX.EXE")
wPSP    equ <[bp+04h]>     ;psp
dwOvl   equ <[bp+00h]>     ;overlay parameter block (2 words)
szParm  equ <[bp-MAXPATH]> ;application name (from environment)

launch  proc

		INT	21h
		JB error2  			;---> error "rc xx from ..."

		mov	word ptr dwOvl,0
		lea	dx,szPgm		;full path of 'DPMILDXX.EXE'
		mov bx,sp			;=lea bx,szParm	;name of application to start
		mov	es,wPSP
		jmp	dword ptr dwOvl
errorX:: 					;<--- errors
		push cs
        pop ds
		call DispError
		call DispFatal
		mov	ax,4CF0h		;error code F0h
		int	21h
DispFatal:					;display "program loading aborted"
		MOV	DX,offset dFatal
DispError:					;display error msg in DX
		MOV	AH,09h
		INT	21h
		ret
error2: 					;error 'rc xx from loading overlay'
		mov	dx,offset dError2
		push offset errorX
		mov	bx,offset myrc+1
        db 0D4h,10h			;AAM 10h  (AX=001A -> AX=010A)
		call nibout
        mov al,ah
nibout:
		cmp	al,10			;bugfix reported by DOS386
		sbb	al,69h			;00-09 -> 96-9F, 0A-0F -> A1-A6
		das					;96-9F -> 30-39, A1-A6 -> 41-46
		mov	[bx],al
		dec	bx
		ret
launch  endp

dFatal	db cr,lf,'program loading aborted',cr,lf,'$'
dError2	db cr,lf,"rc "
myrc    db 0,0
		db " from loading overlay",cr,lf,'$'

		align 2

endcopy label byte

szPath  db   'PATH='
SIZPATH equ $ - szPath

dNotFnd db cr,lf,'cannot find loader '
ldrname	label byte
if ?32BIT
		db 'DPMILD32.EXE'
else
		db 'DPMILD16.EXE'
endif
SIZLDRNAME equ $ - ldrname
		db '$'

dMemory	db cr,lf,"insufficient memory",cr,lf,'$'

memerr:
		mov	dx,offset dMemory
		jmp	errorX

main    proc

;--- setup stack at end of memory block

		cld
		mov	ax,ds:[0002]
		push cs
		pop	ds
		mov	bp,es
        push ax
        sub ax,bp
		cmp	ax,?MINMEM+30h	;enough free memory in this block?
        pop ax
		jc memerr
        
		sub	ax,30h
		mov	ss,ax
		mov	sp,300h-MAXPATH

;--- setup BP stack frame

        push es				;wPSP
        push ds				;dwOvl+2
        push ds				;dwOvl+0
		mov	BP,SP
		sub	SP,MAXPATH

;--- fill szParm with application name

		mov	SI,SP    		;SI=szParm
		mov	es,es:[002Ch]	;ES=environment
		CALL GetAppName

;--- search "PATH=", DI=NULL if it doesn't exist

		CALL SearchPath
		MOV	SI,DI			;set SI to start of PATH= value

;--- fill szPgm (search DPMILDxx)

		push SS
		pop	DS
		CALL SearchLdr
		MOV	DX,offset dNotFnd
		JB errorX  			;---> error "not found"

;--- copy the final code to end of memory block

		mov cx,offset endcopy
		push ss
        pop es
		xor	di,di
		xor	si,si
        db 2Eh				;CS prefix
		rep	movsb

;--- set registers AX,BX,DX for int 21h, ax=4b03h call

		MOV	AX,4B03h		;load as overlay
		mov	BX,BP			;=lea BX, dwOvl
		lea	DX,szPgm		;path for DPMILD16/32.EXE

		push ds
		push cx
		retf

main    endp

;--- search name of app in environment
;--- the name may be a full path or not
;--- depending on caller
;--- in: ES=environment, SS:SI=dest
;--- modifies AX,CX,SI,DI

GetAppName proc
		SUB	DI,DI
		mov	al,00
		mov	cx,-1
@@:
		repnz scasb		;search end of environ (00,00)
		scasb
		jnz	@B
		inc	di			;skip 0001
		inc	di

@@:
		mov al,es:[di]
        mov ss:[si],al
        inc si
        inc di
		and	al,al
		jnz	@B
		RET
GetAppName endp

;--- search PATH= in Environment
;--- In: ES=environment
;--- Out: DI-> behind "PATH=" or NULL
;--- modifies AX,CX,SI,DI

SearchPath proc
		SUB	DI,DI
nextitem:
		MOV SI,offset szPath
		MOV	CX,SIZPATH
		REPZ CMPSB
		JZ 	found
		mov	al,00
		mov	ch,7Fh
		repnz scasb
		cmp	al,es:[di]
		JNZ	nextitem
		sub	di,di
found:
		RET
SearchPath endp

;--- search DPMILDxx, first in current Dir, then scan PATH
;--- Input: ES=environ, SI=address PATH variable or 0000 (no PATH exists)
;--- Output: NC if found, C if error
;--- full loader path in szPgm
;--- modifies AX,BX,CX,DX,SI,DI

SearchLdr proc
		lea	DI,szPgm
        mov dx,di
nextitem:								;<----
		PUSH SI
		mov	si,offset ldrname			;Name "DPMILDXX.EXE"
		mov	cx,SIZLDRNAME
@@:
		db 2Eh		;CS prefix
        lodsb
        mov [di],al
        inc di
        loop @B
		mov	[di],cl

		MOV	AX,3D00h or _SFLAGS_		;open DPMILDXX.EXE
		INT	21h
		POP	SI
		JNB	found						;jmp if found!
		AND	SI,SI
        stc
		JZ 	notfound					;PATH not defined, so we are done
		MOV	DI,DX
        mov cx,MAXDIR
@@:
		mov al,es:[si]
        mov [di],al
        inc si
        inc di
		CMP	AL,';'
		JZ 	@F
		CMP	AL,00
		LOOPNZ @B						;PATH done
		XOR	SI,SI
@@:
		DEC	DI
		CMP	Byte Ptr [DI-01],'\'
		JZ 	nextitem
		MOV	Byte Ptr [DI],'\'
		INC	DI
		JMP	nextitem
found:
		XCHG ax,bx			;=MOV BX,AX
		MOV	AH,3Eh			;close file
		INT	21h
		CLC
notfound:
		RET
SearchLdr endp

ifndef ?POWERPACK
        org 1C0h
endif

_TEXT   ends

        end main

